import java, os, sys, shutil
from java.lang import *
from java.sql import *
from jarray import array, zeros
from java.io import *
from weblogic.security.internal.encryption.ClearOrEncryptedService import *
from weblogic.security.internal.SerializedSystemIni import *

from weblogic.jms.extensions import JMSMessageInfo
from weblogic.messaging.runtime import MessageInfo
from weblogic.messaging.kernel import Cursor
  
#from weblogic.apache.xerces.dom import DocumentImpl
#from weblogic.apache.xml.serialize import OutputFormat
#from weblogic.apache.xml.serialize import XMLSerializer
  
from java.io import File
from java.io import FileOutputStream
from java.io import OutputStreamWriter
from java.io import BufferedWriter
from java.io import Writer
from java.io import IOException
from java.util import ArrayList
from java.util import Collection

from java.io import ByteArrayOutputStream 
from java.io import StringBufferInputStream
 
from java.util import Properties
from java.util import Date
 
from java.lang import *
 
from cnam.outil.mbean.jms import ExportMessages
from cnam.outil.mbean.jms import ImportMessages
from cnam.outil.mbean.jms import StringUtil
 
import jarray
import sys

#######################################################################################################################################################
# EXPORT des messages JMS en fichier xml
#######################################################################################################################################################

"""
QUERY : message selection or message filter

The selector is a regular boolean expression consists of a string with syntax similar to where clause of an SQL select statement. 
Selector can include various attributes associated with the messages headers and properties. WebLogic JMS allows the users to create 
selector expression based on JMS message header fields and or property fields. In addition to the standard JMS message header fields, 
you can also use the WebLogic specific system properties such as JMS_BEA_UnitOfOrder, JMS_BEA_Size and JMS_BEA_State. 

Contents of the message body cannot be used as part of the filter expression except for XMLMessage type. For XML message types, 
WebLogic provides a special syntax called JMS_BEA_SELECT based on XPATH expression in addition to the standard SQL select syntax. 
The XML selector can be used to select messages based on the content of the XML message body.

QUERY : <Property Name> <operator> <value> 

operator : <, >, =, LIKE (with %)

*----------------------*-------------------------------------*-------------------------------------------------------------------------
Property Name					 |Description													 |Values
*----------------------*-------------------------------------*-------------------------------------------------------------------------
METADATA
*----------------------*-------------------------------------*-------------------------------------------------------------------------
JMS_BEA_UnitOfOrder			The Unit Of Order Identifier					A valid client or system generated string representation of a UOO ID
JMS_BEA_Size						The size of the message in bytes			A long value
JMS_BEA_State						The current state of the message			String literal
JMS_BEA_SequenceNumber	The sequence number assigned to 			A long value.
												messages by the system upon arrival 
												on the destination
JMS_BEA_DeliveryTime		Birth time of the message							A long value
JMS_BEA_RedeliveryLimit	The number of the redelivery 					A long value
												attempts to be made before moving 
												the message onto error destination 
JMSXDeliveryCount				The number of times the message has 	A long value
												been delivered to the client												
*----------------------*-------------------------------------*-------------------------------------------------------------------------
HEADER
*----------------------*-------------------------------------*-------------------------------------------------------------------------
JMSMessageID							
JMSDeliveryMode					
JMSExpiration
JMSPriority
JMSRedelivered
JMSTimestamp
*----------------------*-------------------------------------*-------------------------------------------------------------------------



JMS_BEA_State
*------------------------*-------------------------------------------------------*-----------*----------------------------------------------
State										 |Description																						 |Bitmask		 |String literal to be used in message selector
*------------------------*-------------------------------------------------------*-----------*----------------------------------------------
Visible										The message is visible on the destination and 					1						visible
													may be consumed		
Send											The message is pending because it is associated with 		2						send
													an in progress send operation
Received									The message is pending because it has been received 		4						receive
													by a consumer but not yet acknowledged
Transaction								The message is associated with a transactional 					8						send transaction or receive transaction
													send or receive operation that is in progress.
Ordered										The message belongs to a Unit of Order.									16					ordered
Delayed										The message is pending because it has a scheduled 			32					delayed
													delivery time or is otherwise delayed.
Expired										The message has expired and is no longer available 			64					expired
													for consumption.							
Redelivery-count-exceeded	The message has exceeded the redelivery count set for 	128					redelivery-count-exceeded	
													the destination and is no longer available for 
													consumption							
Paused										The message is pending because of a destination					256					paused 
													pause operation							
Sequenced									The message that is part of a SAF sequence							512					sequenced
Unit of work component		The message is part of an Unit of work (UOW)						1024				unit-of-work-component
Deleted										The message marked for deletion													1073741824	deleted													
*-------------------------*-------------------------------------------------------*-----------*----------------------------------------------


Sample

	Get all the messages that are in the queue with priority great than 5
JMSPriority > 5

	Get all the messages that belong to the unit-of-order BLUE
JMS_BEA_UnitOfOrder LIKE BLUE

	Get all the messages that are bigger than 1k size
JMS_BEA_Size > 1024

	Get all the messages that are pending as part of a receive transaction
JMS_BEA_State LIKE receive transaction
					
"""




# Export sur un fichier unique d'un message d'une queue (distribue ou non ) identifie par son ID
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def exportQueueMessageToFileById( ID , outputFileName ):
	
	exportQueueMessagesToFileFiltered( 'JMSMessageID LIKE \'%'+ID+'%\'', outputFileName )

# Export sur un fichier unique de tous les messages d'une queue (distribue ou non )
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def exportQueueMessagesToFile( outputFileName ):

	exportQueueMessagesToFileFiltered( '', outputFileName )

# Export sur un fichier unique de tous les messages d'une queue (distribue ou non ) avec un filtre
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def exportQueueMessagesToFileFiltered( filter, outputFileName ):
	
	exportMessage = ExportMessages( cmo );
	exportMessage.exportAllMessagesToFile( outputFileName, filter );

# Export dans un repertoire de tous les messages d'une queue (distribue ou non ) (un fichier par message)
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def exportQueueMessagesToDir( outputDirName ):

	exportQueueMessagesToDirFiltered( '', outputDirName )

# Export dans un repertoire de tous les messages d'une queue (distribue ou non ) (un fichier par message) avec un filtre
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def exportQueueMessagesToDirFiltered( filter, outputDirName ):
		
	exportMessage = ExportMessages( cmo );
	exportMessage.exportAllMessagesToDir( outputDirName, '' );

# Import des messages d'un fichier dans une queue (distribue ou non )
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def importQueueMessagesFromFile( inputFileName ):
		
	importMessage = ImportMessages( cmo );
	importMessage.importMessagesFromFile( inputFileName );
	
# Import d'un repertoire de messages dans une queue (distribue ou non )
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def importQueueMessagesFromDir( inputDirName ):
		
	importMessage = ImportMessages( cmo );
	importMessage.importMessagesFromDir( inputDirName );

#######################################################################################################################################################
# LISTE des messages JMS d'une Queue
#######################################################################################################################################################

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def lsMessages() :

	cursor = cmo.getMessages('',0)
	cursorSize = cmo.getCursorSize(cursor)
		
	if cursorSize == 0 :
		return
    
	while 1:	

		m = cmo.getNext(cursor,1)
				
		if m is None:
			break
    
		jmsmsginfo = JMSMessageInfo(m[0])
		wlmsg = jmsmsginfo.getMessage()
		wlmsgid = wlmsg.getJMSMessageID()
		fullcursormsg = cmo.getMessage(cursor,wlmsgid)
		fulljmsmsginfo = JMSMessageInfo(fullcursormsg)
		fullwlmsg = fulljmsmsginfo.getMessage()
				
		print fullwlmsg
     
#######################################################################################################################################################
# DELETE des messages JMS d'une Queue
#######################################################################################################################################################

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def deleteMessagesById( ID ) :

	deleteMessagesFiltered( 'JMSMessageID LIKE \'%'+ID+'%\'' )

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def deleteMessagesFiltered( filter ) :

	count = cmo.deleteMessages(filter)
	
	print "-> deleteMessages(%(count)s)" % locals()

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def deleteMessages() :

	deleteMessagesFiltered( '' )
  
#######################################################################################################################################################
# POSE/RESUME ONLINE des queue
#######################################################################################################################################################

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def poseAllOnlineQueue() :

	poseProductionOnlineQueue()
	poseConsumptionOnlineQueue()
	poseInsertionOnlineQueue()

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def poseProductionOnlineQueue() :

	if cmo.productionPaused == true :
		print "-> Production queue %s already paused" % cmo
		return
	else : cmo.pauseProduction()
	
	if cmo.productionPaused == true : print "-> Production queue %s is now paused" % cmo
	else : print "-> !!! cannot paused the Production queue %s" % cmo
		
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def poseConsumptionOnlineQueue() :

	if cmo.consumptionPaused == true :
		print "-> Consumption queue %s already paused" % cmo
		return
	else : cmo.pauseConsumption()
	
	if cmo.consumptionPaused == true : print "-> Consumption queue %s is now paused" % cmo
	else : print "-> !!! cannot paused the Consumption queue %s" % cmo	
		
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def poseInsertionOnlineQueue() :

	if cmo.insertionPaused == true :
		print "-> Insertion queue %s already paused" % cmo
		return
	else : cmo.pauseInsertion()
	
	if cmo.insertionPaused == true : print "-> Insertion queue %s is now paused" % cmo
	else : print "-> !!! cannot paused the Insertion queue %s" % cmo		
		
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeAllOnlineQueue() :

	resumeProductionOnlineQueue()
	resumeConsumptionOnlineQueue()
	resumeInsertionOnlineQueue()	
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeProductionOnlineQueue() :

	if cmo.productionPaused == false :
		print "-> Production queue %s already resumed" % cmo
		return
	else : cmo.resumeProduction()
	
	if cmo.productionPaused == false : print "-> Production queue %s is now resume" % cmo
	else : print "-> !!! cannot resume the Production queue %s" % cmo
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeConsumptionOnlineQueue() :

	if cmo.consumptionPaused == false :
		print "-> Consumption queue %s already resumed" % cmo
		return
	else : cmo.resumeConsumption()
	
	if cmo.consumptionPaused == false : print "-> Consumption queue %s is now resume" % cmo
	else : print "-> !!! cannot resume the Consumption queue %s" % cmo	
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeInsertionOnlineQueue() :

	if cmo.insertionPaused == false :
		print "-> Insertion queue %s already resumed" % cmo
		return
	else : cmo.resumeInsertion()
	
	if cmo.insertionPaused == false : print "-> Insertion queue %s is now resume" % cmo
	else : print "-> !!! cannot resume the Insertion queue %s" % cmo	
	
#######################################################################################################################################################
# POSE/RESUME OFFLINE des queue
#######################################################################################################################################################
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def pauseAllOfflineQueue() :

	pauseOfflineQueue()
	pauseConsumptionOfflineQueue()
	pauseInsertionOfflineQueue()
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def pauseConsumptionOfflineQueue() :
	
	mbean_name=pwd()
		
	if cmo.consumptionPausedAtStartup == true :
		print "-> queue Consumption %s already set to paused at startup" % cmo
		return
	else :
		startTransaction()
		cd(mbean_name)
		cmo.setConsumptionPausedAtStartup(true)
		endTransaction()
		
	if cmo.consumptionPausedAtStartup == true : print "-> queue Consumption %s is now set to paused at startup" % cmo
	else : print "-> !!! cannot paused at startup the queue Consumption %s" % cmo
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def pauseInsertionOfflineQueue() :
	
	mbean_name=pwd()
	
	if cmo.insertionPausedAtStartup == true :
		print "-> queue Insertion %s already set to paused at startup" % cmo
		return
	else :
		startTransaction()
		cd(mbean_name)
		cmo.setInsertionPausedAtStartup(true)
		endTransaction()
	
	if cmo.insertionPausedAtStartup == true : print "-> queue Insertion %s is now set to paused at startup" % cmo
	else : print "-> !!! cannot paused at startup the queue Insertion %s" % cmo		    
  
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def pauseOfflineQueue() :
	
	mbean_name=pwd()

	ls()
	if cmo.productionPausedAtStartup == true :
		print "-> queue %s already set to paused at startup" % cmo
		return
	else :
		startTransaction()
		cd(mbean_name)
		cmo.setProductionPausedAtStartup(true)
		endTransaction()
	
	if cmo.productionPausedAtStartup == true : print "-> queue %s is now set to paused at startup" % cmo
	else : print "-> !!! cannot paused at startup the queue %s" % cmo
  
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeAllOfflineQueue() :

	resumeOfflineQueue()
	resumeConsumptionOfflineQueue()
	resumeInsertionOfflineQueue()	
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeOfflineQueue() :

	mbean_name=pwd()

	if cmo.productionPausedAtStartup == false :
		print "-> ProductionPause queue %s already resumed" % cmo
		return
	else : 
		startTransaction()
		cd(mbean_name)
		cmo.setProductionPausedAtStartup(false)
		endTransaction()
		
	if cmo.productionPausedAtStartup == false : print "-> ProductionPause queue %s is now resume" % cmo
	else : print "-> !!! cannot resume the ProductionPause queue %s" % cmo

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeInsertionOfflineQueue() :


	mbean_name=pwd()
	
	if cmo.insertionPausedAtStartup == false :
		print "-> Insertion queue %s already resumed" % cmo
		return
	else : 
		startTransaction()
		cd(mbean_name)
		cmo.setInsertionPausedAtStartup(false)
		endTransaction()
		
	if cmo.insertionPausedAtStartup == false : print "-> Insertion queue %s is now resume" % cmo
	else : print "-> !!! cannot resume the Insertion queue %s" % cmo
  
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def resumeConsumptionOfflineQueue() :

	mbean_name=pwd()

	if cmo.consumptionPausedAtStartup == false :
		print "-> Consumption queue %s already resumed" % cmo
		return
	else : 
		startTransaction()
		cd(mbean_name)
		cmo.setConsumptionPausedAtStartup(false)
		endTransaction()
		
	if cmo.consumptionPausedAtStartup == false : print "-> Consumption queue %s is now resume" % cmo
	else : print "-> !!! cannot resume the Consumption queue %s" % cmo
    
  
  
#######################################################################################################################################################
# Tools
#######################################################################################################################################################

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def cdMbeanQueueDomainRuntime( isDistributed, instanceName, jmsServerName, jmsModuleName, jsmQueueName ) :

	queueName = StringUtil.getQueueName( isDistributed, jmsModuleName, jmsServerName, jsmQueueName)	
	queuePath="domainRuntime:/ServerRuntimes/%(instanceName)s/JMSRuntime/%(instanceName)s.jms/JMSServers/%(jmsServerName)s/Destinations/%(queueName)s" % locals()
	
	try : cd( queuePath )
	except : print "-> cd : wrong mbean path {%(queuePath)s}" % locals()
	else : pass

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def cdMbeanQueueEdit( isDistributed, instanceName, jmsServerName, jmsModuleName, jsmQueueName ) :

	if isDistributed : queuePath = 'edit:/JMSSystemResources/%(jmsModuleName)s/JMSResource/%(jmsModuleName)s/UniformDistributedQueues/%(jsmQueueName)s' % locals()
	else : queuePath = 'edit:/JMSSystemResources/%(jmsModuleName)s/JMSResource/%(jmsModuleName)s/Queues/%(jsmQueueName)s' % locals()

	try : cd( queuePath )
	except : print "-> cd : wrong mbean path {%(queuePath)s}" % locals()
	else : pass


def getFirtsFromListID() :

	cursor = cmo.getMessages('',0)
	cursorSize = cmo.getCursorSize(cursor)
		
	if cursorSize == 0 : return
    
	m = cmo.getNext(cursor,1)
			
	if m is None: return
  
	jmsmsginfo = JMSMessageInfo(m[0])
	wlmsg = jmsmsginfo.getMessage()
	wlmsgid = wlmsg.getJMSMessageID()
	fullcursormsg = cmo.getMessage(cursor,wlmsgid)
	fulljmsmsginfo = JMSMessageInfo(fullcursormsg)
	fullwlmsg = fulljmsmsginfo.getMessage()
			
	return wlmsgid









#=======================================================================================
# Start/End Transaction
#=======================================================================================

#--------------------------------------------------------------------------------------------------------------------------------------------------------
def is_session_active():
			
	signiature="Tools : is_session_active()"
			
	is_=false
	
	try :
		
		cmgr=getConfigManager()
		user=cmgr.getCurrentEditor()

		if user != None :  is_ = true
		
	except Exception, e : raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)
	
	return is_
		
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def release_session():
		
	signiature="Tools : release_session()"
		
	try :		
	
		cmgr=getConfigManager()
		cmgr.undo()
		cmgr.cancelEdit()		
		
	except Exception, e : raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def startTransaction():

	signiature="Tools.py : startTransaction( type=[%s] )" % type

	try :

		if is_session_active() : release_session()
		
		edit()
		startEdit(exclusive='true')

	except Exception, e : raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)
		
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def endTransaction():	

	signiature="Tools.py : endTransaction( type=[%s] )" % type
	
	try :

		if is_session_active() :
		
			save()
			activate(block="true")					
				
	except Exception, e :

		cancelTransaction(type)
		raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)
	
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def cancelTransaction():
	
	signiature="Tools.py : cancelTransaction( type=[%s] )" % type

	try :
		
		cancelEdit('y')
		startTransaction( type )					
				
	except Exception, e : raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)
	
#--------------------------------------------------------------------------------------------------------------------------------------------------------
def commitTransaction():
	
	signiature="Tools.py : commitTransaction( type=[%s] )" % type
	
	try :

		endTransaction()
		startTransaction()
	
	except Exception, e :

		raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)	
		
		
		
		
		
		
		
		
		
		
"""
	propertie file
"""

def decrypt( boot_file,  SerializedSystemIni_file, SerializedSystemIni_dir ) :

	signiature="Tools.py : decrypt( boot_file=(%s),  SerializedSystemIni_file=(%s) )" % ( boot_file,  SerializedSystemIni_file )

	username_password={}

	try :
	
		if not is_file(boot_file) or not is_file(SerializedSystemIni_file) : 
			print "no %s or %s " % (boot_file,SerializedSystemIni_file)
			return username_password

		boot_dic=loadPropsIntoDictionary(boot_file)

		usernameDecrypted=boot_dic['username']
		passwordDecrypted=boot_dic['password']
		
		EncryptionService=weblogic.security.internal.SerializedSystemIni.getEncryptionService( SerializedSystemIni_dir )
		EncryptedObj=weblogic.security.internal.encryption.ClearOrEncryptedService( EncryptionService )
		username_password['username']=EncryptedObj.decrypt(usernameDecrypted)
		username_password['password']=EncryptedObj.decrypt(passwordDecrypted)
	
		print "[%s]" % EncryptedObj.decrypt(usernameDecrypted)
		print "[%s]" % EncryptedObj.decrypt(passwordDecrypted)

	except Exception, e :

		print "-> ERROR [%s] - %s!!!" % (e.getMessage(),signiature)
		raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)

	return username_password		
	
	
	
	
	
	
	
def loadPropsIntoDictionary( configPropFile ):

	signiature="Tools.py : loadProps( configPropFile=[%s] )" % configPropFile
	
	if not os.path.exists( configPropFile ) :
			
		print "< ERROR : cannot find file [%s]  - %s !!!" % (configPropFile,signiature)
		raise Exception, "%s : ERROR : cannot find file [%s] !!!" % (signiature,configPropFile)
	
	dict={}
	
	try :
	
		propInputStream = FileInputStream(configPropFile)
		configProps = Properties()
		configProps.load(propInputStream)
		for var in configProps.keys() :
			val=configProps.get(var)
			val=val.strip()
			dict[var]=val
	
	except Exception, e :			
			
		print "< ERROR [%s] - %s!!!" % (e.getMessage(),signiature)
		raise Exception, "%s : ERROR [%s] !!!" % (signiature,e.getMessage)
					
	return dict
	
	
"""
	is a file
	ex:
		is_file( 'D:\BEA\domaine\toto.txt' )
"""

def is_file( path ):

	path_file = java.io.File( path )
	
	if  path_file.isFile() & path_file.canRead() : return true
	else : return false
	
	